#pragma once

#include <Bild.h>
#include "Schuss.h"
#include "Ship.h"
#include "Asteroid.h"

class GameData
{
protected:
    Welt2D *world;
    RCArray< Schuss > *schuss;
    Ship *ship;
    RCArray< Asteroid > *asteroid;
    Model2DData **aData;
    Model2DData **sData;
    int shipN;
    int score;
    int scoreCheck;
    int breite;
    int hhe;
    int aGre;
    int mTimer;
    int maxTimer;
    double timer;
    bool beendet;
    bool rend;
    double gameTime;
    Critical cs;
    RandomGenerator *rGen;
    char tastenStnde;
    int ref;

    virtual Asteroid *createNewAsteroid();

public:
    // Konstructor
    GameData( const char *shipM2, const char *asteroidsM2 );
    // Destructor
    virtual ~GameData();
    // nicht constant
    virtual void reset( Text *zOptionen );
    virtual bool tick( double t );
    // constant
    int getScore() const;
    bool istBeendet() const;
    // Reference Counting
    GameData *getThis();
    GameData *release();
};