#ifndef Map_H
#define Map_H

#include <Random.h>
#include <Textur2D.h>
#include "Data.h"
#include "KSGNetwork.h"
#include <Kamera2D.h>

using namespace Framework;

class Map : public GameData
{
private:
    Kamera2D *kamera;
    Kamera2D *mapKamera;
    LRahmen *map;
    Datei capture;
    KSGClient::MinigameServerClient *klient;
    Textur2D *flammenM;
    Textur2D *flammenL;
    Textur2D *flammenR;
    Bild **aTextur;
    Bild **sTextur;

    Asteroid *createNewAsteroid() override;
public:
    // Konstruktor
    Map( KSGClient::MinigameServerClient *klientd );
    // Destruktor
    ~Map();
    // nicht constant
    void reset( Text *zOptionen ) override;
    void doMausEreignis( MausEreignis &me );
    void doTastaturEreignis( TastaturEreignis &te );
    bool tick( double t ) override;
    void render( Bild &zRObj );
    void speichern();
};

#endif